VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "class_ini_file"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'This software comes with ABSOLUTELY NO WARRANTY. This is a free software under GNU GPL licence.
'Created by Jacquelin POTIER jacquelin.potier@libertysurf.fr
'ie reader 2002

Option Explicit
Private file_name As String

Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long

Private Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Private Function GetWindowsDir() As String
    On Error Resume Next
    Dim Temp As String
    Dim Ret As Long
    Const MAX_LENGTH = 145

    Temp = String$(MAX_LENGTH, 0)
    Ret = GetWindowsDirectory(Temp, MAX_LENGTH)
    Temp = Left$(Temp, Ret)
    If Temp <> "" And Right$(Temp, 1) <> "\" Then
        GetWindowsDir = Temp & "\"
    Else
        GetWindowsDir = Temp
    End If
End Function

Public Sub read_web_page()
    'load web_page options
    With ie_options
        .auto_read_when_doc_completed = get_bool_value(read_one_str_record("webpage", "auto_read_when_doc_completed", "True"))
        .read_a_tag = get_bool_value(read_one_str_record("webpage", "read_a_tag", "True"))
        .read_div_tag = get_bool_value(read_one_str_record("webpage", "read_div_tag", "True"))
        .read_font_tag = get_bool_value(read_one_str_record("webpage", "read_font_tag", "True"))
        .read_img_tag = get_bool_value(read_one_str_record("webpage", "read_img_tag", "True"))
        .read_input_tag = get_bool_value(read_one_str_record("webpage", "read_input_tag", "True"))
        .read_option_tag = get_bool_value(read_one_str_record("webpage", "read_option_tag", "True"))
        .read_p_tag = get_bool_value(read_one_str_record("webpage", "read_p_tag", "True"))
        .read_select_tag = get_bool_value(read_one_str_record("webpage", "read_select_tag", "True"))
        .read_span_tag = get_bool_value(read_one_str_record("webpage", "read_span_tag", "True"))
        .read_td_tag = get_bool_value(read_one_str_record("webpage", "read_td_tag", "True"))
        .stop_agent_action_when_new_event = get_bool_value(read_one_str_record("webpage", "stop_agent_action_when_new_event", "True"))
        
        .txt_before_button = read_one_str_record("webpage", "txt_before_button", "Button")
        .txt_before_checkbox = read_one_str_record("webpage", "txt_before_checkbox", "Checkbox")
        .txt_before_image_tag = read_one_str_record("webpage", "txt_before_image_tag", "Image")
        .txt_before_link = read_one_str_record("webpage", "txt_before_link", "Link")
        .txt_before_option_tag = read_one_str_record("webpage", "txt_before_option_tag", "Option")
        .txt_before_password = read_one_str_record("webpage", "txt_before_password", "Password")
        .txt_before_radio = read_one_str_record("webpage", "txt_before_radio", "Radio")
        .txt_before_select_tag = read_one_str_record("webpage", "txt_before_select_tag", "Select")
        .txt_before_text_input = read_one_str_record("webpage", "txt_before_text_input", "Input text")
    End With
End Sub

Public Sub update_web_page()
    'save web_page options
    With ie_options
        write_one_str_record "webpage", "auto_read_when_doc_completed", get_english_value(.auto_read_when_doc_completed)
        write_one_str_record "webpage", "read_a_tag", get_english_value(.read_a_tag)
        write_one_str_record "webpage", "read_div_tag", get_english_value(.read_div_tag)
        write_one_str_record "webpage", "read_font_tag", get_english_value(.read_font_tag)
        write_one_str_record "webpage", "read_img_tag", get_english_value(.read_img_tag)
        write_one_str_record "webpage", "read_input_tag", get_english_value(.read_input_tag)
        write_one_str_record "webpage", "read_option_tag", get_english_value(.read_option_tag)
        write_one_str_record "webpage", "read_p_tag", get_english_value(.read_p_tag)
        write_one_str_record "webpage", "read_select_tag", get_english_value(.read_select_tag)
        write_one_str_record "webpage", "read_span_tag", get_english_value(.read_span_tag)
        write_one_str_record "webpage", "read_td_tag", get_english_value(.read_td_tag)
        write_one_str_record "webpage", "stop_agent_action_when_new_event", get_english_value(.stop_agent_action_when_new_event)
        
        write_one_str_record "webpage", "txt_before_button", .txt_before_button
        write_one_str_record "webpage", "txt_before_checkbox", .txt_before_checkbox
        write_one_str_record "webpage", "txt_before_image_tag", .txt_before_image_tag
        write_one_str_record "webpage", "txt_before_link", .txt_before_link
        write_one_str_record "webpage", "txt_before_option_tag", .txt_before_option_tag
        write_one_str_record "webpage", "txt_before_password", .txt_before_password
        write_one_str_record "webpage", "txt_before_radio", .txt_before_radio
        write_one_str_record "webpage", "txt_before_select_tag", .txt_before_select_tag
        write_one_str_record "webpage", "txt_before_text_input", .txt_before_text_input
    End With

End Sub
Public Sub read_agent()
    On Error Resume Next
    'load agent options
    agent_options.agent_name = read_one_str_record("agent", "agent_name", "merlin")
    agent_options.agents_folder = read_one_str_record("agent", "agents_folder", GetWindowsDir & "msagent\chars\")
    agent_options.ballon_on = get_bool_value(read_one_str_record("agent", "ballon_on", "False"))
    agent_options.default_voice = get_bool_value(read_one_str_record("agent", "default_voice", "True"))
    agent_options.language = read_one_str_record("agent", "language", "English (US)")
    agent_options.language_engine = get_bool_value(read_one_str_record("agent", "language_engine", "False"))
    agent_options.tts_engine = read_one_str_record("agent", "tts_engine", "Carol, British English, L&H TTS3000")
    agent_options.voice_character = read_one_str_record("agent", "voice_character", "Normal")
    agent_options.voice_context = read_one_str_record("agent", "voice_context", "Unknown")
    agent_options.voice_pitch = CInt(read_one_str_record("agent", "voice_pitch", "150"))
    agent_options.voice_speed = CInt(read_one_str_record("agent", "voice_speed", "150"))
End Sub

Public Sub update_agent()
    On Error Resume Next
    'save agent options
    write_one_str_record "agent", "agent_name", agent_options.agent_name
    write_one_str_record "agent", "agents_folder", agent_options.agents_folder
    write_one_str_record "agent", "ballon_on", get_english_value(agent_options.ballon_on)
    write_one_str_record "agent", "default_voice", get_english_value(agent_options.default_voice)
    write_one_str_record "agent", "language", agent_options.language
    write_one_str_record "agent", "language_engine", get_english_value(agent_options.language_engine)
    write_one_str_record "agent", "tts_engine", agent_options.tts_engine
    write_one_str_record "agent", "voice_character", agent_options.voice_character
    write_one_str_record "agent", "voice_context", agent_options.voice_context
    write_one_str_record "agent", "voice_pitch", CStr(agent_options.voice_pitch)
    write_one_str_record "agent", "voice_speed", CStr(agent_options.voice_speed)
End Sub


Private Sub write_one_str_record(section As String, key As String, key_value As String)
    On Error Resume Next
    WritePrivateProfileString section, key, key_value, file_name
End Sub

Private Function read_one_str_record(section As String, key As String, default_value As String) As String
    On Error Resume Next
    Dim nb_char_retour  As Integer
    Dim retour          As String * 300
    nb_char_retour = GetPrivateProfileString(section, key, default_value, retour, 300, file_name)
    read_one_str_record = Left$(retour, nb_char_retour)
End Function

Private Function get_bool_value(strvalue As String) As Boolean
    If LCase$(strvalue) = "true" Then get_bool_value = True
End Function

Private Function get_english_value(var As Boolean) As String
    If var Then ' to avoid language troubles
        get_english_value = "True"
    Else
        get_english_value = "False"
    End If
End Function

Private Sub Class_Initialize()
    file_name = App.Path & "\iereader.ini"
End Sub
