VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form form_agent_config 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Character Options"
   ClientHeight    =   4020
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6795
   Icon            =   "form_config.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4020
   ScaleWidth      =   6795
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmd_browse 
      Caption         =   "Browse"
      Height          =   255
      Left            =   2640
      TabIndex        =   21
      Top             =   360
      Width           =   735
   End
   Begin VB.CommandButton cmd_cancel 
      Caption         =   "Cancel"
      Height          =   255
      Left            =   3570
      TabIndex        =   13
      Top             =   3720
      Width           =   1095
   End
   Begin VB.CommandButton cmd_ok 
      Caption         =   "OK"
      Height          =   255
      Left            =   2130
      TabIndex        =   12
      Top             =   3720
      Width           =   1095
   End
   Begin VB.TextBox txt_agent_dir 
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Top             =   360
      Width           =   2415
   End
   Begin VB.OptionButton option_following_voice 
      Caption         =   "Use the following options"
      Height          =   255
      Left            =   3600
      TabIndex        =   6
      Top             =   480
      Width           =   2175
   End
   Begin VB.OptionButton option_default_voice 
      Caption         =   "Use default voice options"
      Height          =   255
      Left            =   3600
      TabIndex        =   5
      Top             =   120
      Value           =   -1  'True
      Width           =   2295
   End
   Begin VB.Frame frame_following_option 
      Height          =   3015
      Left            =   3600
      TabIndex        =   7
      Top             =   480
      Width           =   3135
      Begin VB.ComboBox combo_voice_character 
         Height          =   315
         Left            =   840
         Style           =   2  'Dropdown List
         TabIndex        =   10
         Top             =   1800
         Width           =   1575
      End
      Begin VB.ComboBox combo_voice_context 
         Height          =   315
         Left            =   840
         Style           =   2  'Dropdown List
         TabIndex        =   11
         Top             =   2520
         Width           =   1575
      End
      Begin MSComctlLib.Slider slider_speed 
         Height          =   255
         Left            =   240
         TabIndex        =   8
         Top             =   720
         Width           =   2775
         _ExtentX        =   4895
         _ExtentY        =   450
         _Version        =   393216
         LargeChange     =   10
         SmallChange     =   5
         Min             =   50
         Max             =   250
         SelStart        =   50
         TickStyle       =   3
         TickFrequency   =   50
         Value           =   50
      End
      Begin MSComctlLib.Slider slider_pit 
         Height          =   255
         Left            =   240
         TabIndex        =   9
         Top             =   1320
         Width           =   2775
         _ExtentX        =   4895
         _ExtentY        =   450
         _Version        =   393216
         LargeChange     =   10
         SmallChange     =   5
         Min             =   50
         Max             =   250
         SelStart        =   50
         TickStyle       =   3
         TickFrequency   =   50
         Value           =   50
      End
      Begin VB.Label label_voice_context 
         Caption         =   "Context of the output text"
         Height          =   255
         Left            =   120
         TabIndex        =   17
         Top             =   2280
         Width           =   1935
      End
      Begin VB.Label label_voice_char 
         Caption         =   "Character of the voice"
         Height          =   255
         Left            =   120
         TabIndex        =   16
         Top             =   1560
         Width           =   1695
      End
      Begin VB.Label label_speed 
         Caption         =   "Speed (in words per minute)"
         Height          =   255
         Left            =   120
         TabIndex        =   15
         Top             =   360
         Width           =   2055
      End
      Begin VB.Label label_pitch 
         Caption         =   "Pitch (in hertz)"
         Height          =   255
         Left            =   120
         TabIndex        =   14
         Top             =   1080
         Width           =   1215
      End
   End
   Begin VB.CheckBox chckballon 
      Caption         =   "Ballon"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   3000
      Value           =   1  'Checked
      Width           =   975
   End
   Begin VB.ComboBox combo_agent 
      Height          =   315
      Left            =   120
      Style           =   2  'Dropdown List
      TabIndex        =   1
      Top             =   1080
      Width           =   1935
   End
   Begin VB.ComboBox combo_tts_mode 
      Height          =   315
      Left            =   120
      Style           =   2  'Dropdown List
      TabIndex        =   3
      Top             =   2400
      Width           =   3135
   End
   Begin VB.ComboBox combo_tts_language 
      Height          =   315
      Left            =   120
      Style           =   2  'Dropdown List
      TabIndex        =   2
      Top             =   1920
      Width           =   1935
   End
   Begin VB.Label Label1 
      Caption         =   "Agent's Directory"
      Height          =   255
      Left            =   120
      TabIndex        =   20
      Top             =   120
      Width           =   1335
   End
   Begin VB.Label Label6 
      Caption         =   "Language or voice engine"
      Height          =   255
      Left            =   120
      TabIndex        =   19
      Top             =   1560
      Width           =   1935
   End
   Begin VB.Label Label5 
      Caption         =   "Agent"
      Height          =   255
      Left            =   120
      TabIndex        =   18
      Top             =   720
      Width           =   615
   End
End
Attribute VB_Name = "form_agent_config"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'This software comes with ABSOLUTELY NO WARRANTY. This is a free software under GNU GPL licence.
'Created by Jacquelin POTIER jacquelin.potier@libertysurf.fr
'Simple reader 2002

Option Explicit
Private interface_initialized   As Boolean
Private language_engine         As Boolean
Private no_need_to_reload_agent As Boolean

Public Sub my_unload()
    no_need_to_reload_agent = True
    Unload Me
End Sub

Public Sub my_show()
    On Error Resume Next
    interface_initialized = False
    priv_ini_show
    Me.combo_tts_language.text = agent_options.language
    Me.combo_tts_mode.text = agent_options.tts_engine
    Me.Show
    interface_initialized = True
End Sub

Private Sub priv_ini_show()
    On Error Resume Next
    'init of the form
    no_need_to_reload_agent = False
    language_engine = agent_options.language_engine
    If agent_options.ballon_on Then
        Me.chckballon.value = vbChecked
    Else
        Me.chckballon.value = vbUnchecked
    End If
    obj_agent.fill_agent_combobox Me.combo_agent, agent_options.agents_folder
    obj_agent.fill_voice_character_combobox Me.combo_voice_character
    obj_agent.fill_voice_context_combobox Me.combo_voice_context
    tts_engine.fill_language_combobox Me.combo_tts_language
    tts_engine.fill_ttsmode_combobox Me.combo_tts_mode
    
    Me.txt_agent_dir.text = agent_options.agents_folder
    Me.combo_voice_character.text = agent_options.voice_character
    Me.combo_voice_context.text = agent_options.voice_context
    Me.slider_speed.value = agent_options.voice_speed
    Me.slider_pit.value = agent_options.voice_pitch
    Me.combo_agent.text = agent_options.agent_name
    If agent_options.default_voice Then
        Me.option_default_voice.value = True
        Me.option_following_voice.value = False
        unlock_frame_following_option False
    Else
        Me.option_default_voice.value = False
        Me.option_following_voice.value = True
        unlock_frame_following_option True
    End If

End Sub

Public Sub init_agent_config()
    On Error Resume Next
    interface_initialized = False
    inifile.read_agent
    
    If obj_agent.load_agent(agent_options.agent_name, agent_options.agents_folder) Is Nothing Then Exit Sub
    
    priv_ini_show
    'enable the language or tts engine
    If agent_options.language_engine Then
        Me.combo_tts_language.text = agent_options.language
        interface_initialized = True
        Me.combo_tts_mode.text = agent_options.tts_engine
    Else
        Me.combo_tts_mode.text = agent_options.tts_engine
        interface_initialized = True
        Me.combo_tts_language.text = agent_options.language
    End If
    If agent_options.ballon_on Then
        Me.chckballon.value = vbChecked
        obj_agent.show_ballon
    Else
        Me.chckballon.value = vbUnchecked
        obj_agent.hide_ballon
    End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
    On Error Resume Next
    If Not no_need_to_reload_agent Then 'cancel or close window button
        obj_agent.unload_agent
        'restore agent parameters
        init_agent_config
    End If
End Sub

Private Sub cmd_cancel_Click()
    Unload Me
End Sub

Private Sub cmd_ok_Click()
    On Error Resume Next
    no_need_to_reload_agent = True
    'update option value
    agent_options.agent_name = Me.combo_agent.text
    agent_options.agents_folder = Me.txt_agent_dir.text
    If Me.chckballon.value = vbChecked Then
        agent_options.ballon_on = True
    Else
        agent_options.ballon_on = False
    End If
    agent_options.default_voice = Me.option_default_voice.value
    agent_options.language_engine = language_engine
    agent_options.language = Me.combo_tts_language.text
    agent_options.tts_engine = Me.combo_tts_mode.text
    agent_options.voice_character = Me.combo_voice_character.text
    agent_options.voice_context = Me.combo_voice_context.text
    agent_options.voice_pitch = Me.slider_pit.value
    agent_options.voice_speed = Me.slider_speed.value
    
    inifile.update_agent
    Unload Me
End Sub

Private Sub cmd_browse_Click()
    On Error Resume Next
    Dim foldername As String
    foldername = GetFolderName(Me.hwnd)
    If Right$(foldername, 1) <> "\" Then foldername = foldername & "\"
    Me.txt_agent_dir.text = foldername
    obj_agent.fill_agent_combobox Me.combo_agent, foldername
End Sub

Private Sub combo_agent_Click()
    On Error Resume Next
    If interface_initialized Then
        obj_agent.unload_agent
        obj_agent.load_agent combo_agent.text, txt_agent_dir.text
        'force langage and ballon to be the same for the new agent
        If language_engine Then
            Me.combo_tts_mode.text = Me.combo_tts_mode.text
        Else
            Me.combo_tts_language.text = Me.combo_tts_language.text
        End If
        If Me.chckballon.value = vbChecked Then
            obj_agent.show_ballon
        Else
            obj_agent.hide_ballon
        End If
    End If
End Sub

Private Sub combo_tts_language_Click()
    On Error Resume Next
    Dim languageID As Long
    If interface_initialized Then
        obj_agent.obj_char_ex.Stop
        language_engine = False
        languageID = tts_engine.get_languageID(Me.combo_tts_language.text)
        obj_agent.change_language languageID
    End If
End Sub

Private Sub combo_tts_mode_Click()
    On Error Resume Next
    Dim tts_modeID As String
    If interface_initialized Then
        obj_agent.obj_char_ex.Stop
        language_engine = True
        tts_modeID = tts_engine.get_ttsmodeID(Me.combo_tts_mode.text)
        obj_agent.change_tts_engine tts_modeID
    End If
End Sub

Private Sub combo_voice_character_Click()
    On Error Resume Next
    If interface_initialized Then
        obj_agent.obj_char_ex.Stop
        obj_agent.chrtag = Me.combo_voice_character.text
    End If
End Sub

Private Sub combo_voice_context_Click()
    On Error Resume Next
    If interface_initialized Then
        obj_agent.obj_char_ex.Stop
        obj_agent.ctxtag = Me.combo_voice_context.text
    End If
End Sub

Private Sub chckballon_Click()
    On Error Resume Next
    If Me.chckballon.value = vbChecked Then
        obj_agent.show_ballon
    Else
        obj_agent.hide_ballon
    End If
End Sub

Private Sub unlock_frame_following_option(lock_ As Boolean)
    Me.slider_pit.Enabled = lock_
    Me.slider_speed.Enabled = lock_
    Me.combo_voice_character.Enabled = lock_
    Me.combo_voice_context.Enabled = lock_
    Me.label_pitch.Enabled = lock_
    Me.label_speed.Enabled = lock_
    Me.label_voice_char.Enabled = lock_
    Me.label_voice_context.Enabled = lock_
    agent_options.default_voice = Not lock_
End Sub

Private Sub option_default_voice_Click()
    On Error Resume Next
    obj_agent.obj_char_ex.Stop
    unlock_frame_following_option False
End Sub

Private Sub option_following_voice_Click()
    On Error Resume Next
    obj_agent.obj_char_ex.Stop
    unlock_frame_following_option True
End Sub

Private Sub slider_pit_Change()
    On Error Resume Next
    obj_agent.obj_char_ex.Stop
    obj_agent.pittag = Me.slider_pit.value
End Sub

Private Sub slider_speed_Change()
    On Error Resume Next
    obj_agent.obj_char_ex.Stop
    obj_agent.spdtag = Me.slider_speed.value
End Sub
