VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "class_col_ie_event"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'This software comes with ABSOLUTELY NO WARRANTY. This is a free software under GNU GPL licence.
'Created by Jacquelin POTIER jacquelin.potier@libertysurf.fr
'ie reader 2002

Option Explicit
Private col_ie As Collection 'collection of class_ie_event

'event raised
Public Event BeforeNavigate2(iee As class_ie_event, is_oldest_ie_window As Boolean, pDisp As Object, URL As Variant, Flags As Variant, TargetFrameName As Variant, PostData As Variant, Headers As Variant, Cancel As Boolean)
Public Event DocumentComplete(iee As class_ie_event, is_oldest_ie_window As Boolean, pDisp As Object, URL As Variant)
Public Event Documentonmouseover(objHTMLDocument As MSHTML.HTMLDocument)

'declare for getting and setting windows handle

Private Declare Function GetWindow Lib "user32" (ByVal hwnd As Long, ByVal wCmd As Long) As Long
Private Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

Private Enum getwindowFlags
    GW_CHILD = 5
    GW_HWNDFIRST = 0
    GW_HWNDLAST = 1
    GW_HWNDNEXT = 2
    GW_HWNDPREV = 3
    GW_OWNER = 4
End Enum
 
Private Enum SWPFlags
    SWP_NOSIZE = &H1
    SWP_NOMOVE = &H2
    SWP_NOZORDER = &H4
    SWP_NOREDRAW = &H8
    SWP_NOACTIVATE = &H10
    SWP_FRAMECHANGED = &H20
    SWP_SHOWWINDOW = &H40
    SWP_HIDEWINDOW = &H80
    SWP_NOCOPYBITS = &H100
    SWP_NOOWNERZORDER = &H200
    SWP_NOSENDCHANGING = &H400
    SWP_DRAWFRAME = SWP_FRAMECHANGED
    SWP_NOREPOSITION = SWP_NOOWNERZORDER
    SWP_DEFERERASE = &H2000
    SWP_ASYNCWINDOWPOS = &H4000
End Enum

Private Enum SWPHwnd
    HWND_TOP = &H0
    HWND_BOTTOM = &H1
    HWND_TOPMOST = &HFFFFFFFF
    HWND_NOTOPMOST = &HFFFFFFFE
End Enum



Private Function is_oldest(iee As class_ie_event) As Boolean
    'check if the iee is the oldest <-->check if it is the oldest internet explorer window
    If iee Is col_ie.Item(1) Then is_oldest = True
End Function

Public Sub send_event_BeforeNavigate2(iee As class_ie_event, pDisp As Object, URL As Variant, Flags As Variant, TargetFrameName As Variant, PostData As Variant, Headers As Variant, Cancel As Boolean)
    RaiseEvent BeforeNavigate2(iee, is_oldest(iee), pDisp, URL, Flags, TargetFrameName, PostData, Headers, Cancel)
End Sub

Public Sub send_event_DocumentComplete(iee As class_ie_event, pDisp As Object, URL As Variant)
    RaiseEvent DocumentComplete(iee, is_oldest(iee), pDisp, URL)
End Sub

Public Sub send_event_Documentonmouseover(objHTMLDocument As MSHTML.HTMLDocument)
    RaiseEvent Documentonmouseover(objHTMLDocument)
End Sub

Private Sub Class_Initialize()
    Set col_ie = New Collection
End Sub

Private Sub Class_Terminate()
    Set col_ie = Nothing
End Sub

Public Sub clear()
    Set col_ie = Nothing
    Set col_ie = New Collection
End Sub

Public Sub add(ie As SHDocVw.InternetExplorer, first_addr_defined As Boolean)
    On Error Resume Next
    Dim tmp As New class_ie_event
    tmp.construct ie, Me
    col_ie.add tmp
    tmp.show_ie Not first_addr_defined
    Set tmp = Nothing
End Sub

Public Sub remove(iee As class_ie_event)
    On Error Resume Next
    Dim cpt As Integer
    For cpt = 1 To col_ie.Count
        If iee Is col_ie.Item(cpt) Then
            col_ie.remove cpt
            Exit For
        End If
    Next cpt
End Sub

Public Function get_top_most_ie() As class_ie_event
    On Error Resume Next
    Dim CurrWnd As Long
    Dim tmp As class_ie_event
    If col_ie.Count = 0 Then Exit Function
    
    CurrWnd = GetWindow(form_main.hwnd, GW_HWNDFIRST)

    Do While CurrWnd <> 0
    CurrWnd = GetWindow(CurrWnd, GW_HWNDNEXT)

    Set tmp = is_one_of_ie_page(CurrWnd)
    If Not (tmp Is Nothing) Then
        Set get_top_most_ie = tmp
        'put the corresponding ie window on top
        SetWindowPos CurrWnd, HWND_TOP, 0, 0, 0, 0, SWP_NOSIZE Or SWP_NOMOVE Or SWP_SHOWWINDOW
        Set tmp = Nothing
        Exit Function
    End If
    DoEvents
    Loop

End Function

Private Function is_one_of_ie_page(hwnd As Long) As class_ie_event
    On Error Resume Next
    Dim iee As class_ie_event
    For Each iee In col_ie
        If iee.ie.hwnd = hwnd Then
            Set is_one_of_ie_page = iee
            Set iee = Nothing
            Exit Function
        End If
    Next iee
End Function
