VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "class_tts_engines"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'This software comes with ABSOLUTELY NO WARRANTY. This is a free software under GNU GPL licence.
'Created by Jacquelin POTIER jacquelin.potier@libertysurf.fr
'ie reader 2002

Option Explicit

Private Type tTTSMode
    name        As String
    TTSModeID   As String
End Type
Private array_tts_mode() As tTTSMode

Private Type tlanguage
    name            As String
    languageID      As Long
End Type
Private array_language() As tlanguage

Private Sub Class_Initialize()
    fill_array_language
    fill_array_tts_mode
End Sub

Public Sub fill_language_combobox(combo As ComboBox)
    On Error Resume Next
    Dim cpt As Integer
    combo.clear
    'combo.Style = vbComboDropdownList
    
    For cpt = 0 To UBound(array_language)
        combo.AddItem array_language(cpt).name
    Next cpt
    combo.ListIndex = 0
End Sub

Public Sub fill_ttsmode_combobox(combo As ComboBox)
    On Error Resume Next
    Dim cpt As Integer
    combo.clear
    'combo.Style = vbComboDropdownList
    For cpt = 0 To UBound(array_tts_mode)
        combo.AddItem array_tts_mode(cpt).name
    Next cpt
    combo.ListIndex = 0
End Sub

Public Function get_ttsmodeID(ttsmode_name As String) As String
    On Error Resume Next
    Dim cpt As Integer
    For cpt = 0 To UBound(array_tts_mode)
        If array_tts_mode(cpt).name = ttsmode_name Then
            get_ttsmodeID = array_tts_mode(cpt).TTSModeID
            Exit Function
        End If
    Next cpt
End Function

Public Function get_languageID(language_name As String) As String
    On Error Resume Next
    Dim cpt As Integer
    For cpt = 0 To UBound(array_language)
        If array_language(cpt).name = language_name Then
            get_languageID = array_language(cpt).languageID
            Exit Function
        End If
    Next cpt
End Function

Private Sub add_language(name As String, languageID As Long)
    On Error Resume Next
    Dim array_size As Integer
    array_size = UBound(array_language)
    array_language(array_size).name = name
    array_language(array_size).languageID = languageID
    ReDim Preserve array_language(array_size + 1)
End Sub
Private Sub add_ttsmode(name As String, TTSModeID As String)
    On Error Resume Next
    Dim array_size As Integer
    array_size = UBound(array_tts_mode)
    array_tts_mode(array_size).name = name
    array_tts_mode(array_size).TTSModeID = TTSModeID
    ReDim Preserve array_tts_mode(array_size + 1)
End Sub

Private Sub fill_array_language()
    ReDim array_language(0)
    ''' fill array with the microsoft references
    add_language "Arabic", &H401
    add_language "Basque", &H42D
    add_language "Chinese(Simplified)", &H804
    add_language "Chinese (Traditional)", &H404
    add_language "Croatian", &H41A
    add_language "Czech", &H405
    add_language "Danish", &H406
    add_language "Dutch", &H413
    add_language "English (British)", &H809
    add_language "English (US)", &H409
    add_language "Finnish", &H40B
    add_language "French", &H40C
    add_language "German ", &H407
    add_language "Greek", &H408
    add_language "Hebrew", &H40D
    add_language "Hungarian", &H40E
    add_language "Italian", &H410
    add_language "Japanese", &H411
    add_language "Korean", &H412
    add_language "Norwegian", &H414
    add_language "Polish", &H415
    add_language "Portuguese (Portugal)", &H816
    add_language "Portuguese (Brazil)", &H416
    add_language "Romanian", &H418
    add_language "Russian", &H419
    add_language "Slovakian", &H41B
    add_language "Slovenian", &H424
    add_language "Spanish", &HC0A
    add_language "Swedish", &H41D
    add_language "Thai", &H41E
    add_language "Turkish", &H41F
    '''
    ReDim Preserve array_language(UBound(array_language) - 1)
End Sub


Private Sub fill_array_tts_mode()
    ReDim array_tts_mode(0)
    ''' fill tts mode with microsoft reference
    add_ttsmode "Adult Female #1, US English, L&H TruVoice", "{CA141FD0-AC7F-11D1-97A3-006008273008}"
    add_ttsmode "Adult Female #2, US English, L&H TruVoice", "{CA141FD0-AC7F-11D1-97A3-006008273009}"
    add_ttsmode "Adult Male #1, US English, L&H TruVoice", "{CA141FD0-AC7F-11D1-97A3-006008273000}"
    add_ttsmode "Adult Male #2, US English, L&H TruVoice", "{CA141FD0-AC7F-11D1-97A3-006008273001}"
    add_ttsmode "Adult Male #3, US English, L&H TruVoice", "{CA141FD0-AC7F-11D1-97A3-006008273002}"
    add_ttsmode "Adult Male #4, US English, L&H TruVoice", "{CA141FD0-AC7F-11D1-97A3-006008273003}"
    add_ttsmode "Adult Male #5, US English, L&H TruVoice", "{CA141FD0-AC7F-11D1-97A3-006008273004}"
    add_ttsmode "Adult Male #6, US English, L&H TruVoice", "{CA141FD0-AC7F-11D1-97A3-006008273005}"
    add_ttsmode "Adult Male #7, US English, L&H TruVoice", "{CA141FD0-AC7F-11D1-97A3-006008273006}"
    add_ttsmode "Adult Male #8, US English, L&H TruVoice", "{CA141FD0-AC7F-11D1-97A3-006008273007}"
    add_ttsmode "Carol, British English, L&H TTS3000", "{227A0E40-A92A-11d1-B17B-0020AFED142E}"
    add_ttsmode "Peter, British English, L&H TTS3000", "{227A0E41-A92A-11d1-B17B-0020AFED142E}"
    add_ttsmode "Linda, Dutch, L&H TTS3000", "{A0DDCA40-A92C-11d1-B17B-0020AFED142E}"
    add_ttsmode "Alexander, Dutch, L&H TTS3000", "{A0DDCA41-A92C-11d1-B17B-0020AFED142E}"
    add_ttsmode "Vronique, French, L&H TTS3000", "{0879A4E0-A92C-11d1-B17B-0020AFED142E}"
    add_ttsmode "Pierre, French, L&H TTS3000", "{0879A4E1-A92C-11d1-B17B-0020AFED142E}"
    add_ttsmode "Anna, German, L&H TTS3000", "{3A1FB760-A92B-11d1-B17B-0020AFED142E}"
    add_ttsmode "Stefan, German, L&H TTS3000", "{3A1FB761-A92B-11d1-B17B-0020AFED142E}"
    add_ttsmode "Barbara, Italian, L&H TTS3000", "{7EF71700-A92D-11d1-B17B-0020AFED142E}"
    add_ttsmode "Stefano, Italian, L&H TTS3000", "{7EF71701-A92D-11d1-B17B-0020AFED142E}"
    add_ttsmode "Naoko, Japanese, L&H TTS3000", "{A778E060-A936-11d1-B17B-0020AFED142E}"
    add_ttsmode "Kenji, Japanese, L&H TTS3000", "{A778E061-A936-11d1-B17B-0020AFED142E}"
    add_ttsmode "Shin-Ah, Korean, L&H TTS3000", "{12E0B720-A936-11d1-B17B-0020AFED142E}"
    add_ttsmode "Jun-Ho, Korean, L&H TTS3000", "{12E0B721-A936-11d1-B17B-0020AFED142E}"
    add_ttsmode "Juliana, Portuguese (Brazil), L&H TTS3000", "{8AA08CA0-A1AE-11d3-9BC5-00A0C967A2D1}"
    add_ttsmode "Alexandre, Portuguese (Brazil), L&H TTS3000", "{8AA08CA1-A1AE-11d3-9BC5-00A0C967A2D1}"
    add_ttsmode "Svetlana, Russian, L&H TTS3000", "{06377F80-D48E-11d1-B17B-0020AFED142E}"
    add_ttsmode "Boris, Russian, L&H TTS3000", "{06377F81-D48E-11d1-B17B-0020AFED142E}"
    add_ttsmode "Carmen, Spanish, L&H TTS3000", "{2CE326E0-A935-11d1-B17B-0020AFED142E}"
    add_ttsmode "Julio, Spanish, L&H TTS3000", "{2CE326E1-A935-11d1-B17B-0020AFED142E}"
    '''
    ReDim Preserve array_tts_mode(UBound(array_tts_mode) - 1)
End Sub


